package dbrepo

import (
	"database/sql"
	"go-udemy-web-1/internal/config"
	"go-udemy-web-1/internal/repository"
	"go-udemy-web-1/internal/repository/db"
)

type postgresDBRepo struct {
	App *config.AppConfig
	DB  *sql.DB
}

type pgcDBRepo struct {
	App *config.AppConfig
	Q   *db.Queries
}

type testDBRepo struct {
	App *config.AppConfig
	DB  *sql.DB
}

func NewPostgresRepo(conn *sql.DB, a *config.AppConfig) repository.DatabaseRepo {
	return &postgresDBRepo{
		App: a,
		DB:  conn,
	}
}

func NewTestingRepo(a *config.AppConfig) repository.DatabaseRepo {
	return &testDBRepo{
		App: a,
	}
}

func NewPgcRepo(q *db.Queries, a *config.AppConfig) repository.DatabaseRepo {
	return &pgcDBRepo{
		App: a,
		Q:   q,
	}
}
